<?php

  //require_once('../config.inc.php');
  //require_once('../includes/dbaccess.php');

  /* This is the internal event processor for The Merchant
   * No cron jobs will be needed for this website because this
   * script will make sure that everything runs when needed.
   * I have made sure that this script is well commented so that if
   * a bug were to be in here somewhere it will be easy to find.
   *
   * This script will run every 30 mins exactly, it doesn't have
   * the problem that other internal schedulers have, where they
   * might miss a few seconds or minutes when needed to run
   */

  //$db = new dbaccess;
  //$csector = new currentsector;

  $username = $_SESSION['username'];
  $gameid   = $_SESSION['gameid'];
  $playerid = $tm_player->getplayerid($username,$gameid);
  $playerinf = $tm_player->getplayerinfo($playerid,$gameid);
  $cgameid = $gameid;

  
  //$cgameid = $_SERVER['argv'][1];

  $res = $db->query("SELECT * FROM games WHERE id='$cgameid'");
  while ($r = $db->getarray($res)) {
    $ticktime = $r['ticktime'];
  }

  // First find out when the script was last run
  $res_ep = $db->query("SELECT * FROM eventproc WHERE gameid='$cgameid'");
  $isactive = $db->numResults($res_ep);

  if ($cgameid != 0) {

  // If no records are returned, then this script has never been run
  if ($isactive == 0) {
    $run_times = 1;
    // Run the needed scripts and then update the database

    include("turns.php");
    include("ports_new.php");
    include("alliance_exp.php");
    include("deliveries.php");
    include("constructions.php");
    include("stationshields.php");

    // The current hour
    $currhour = date("G");
    // When is the next run
    $nextrun = mktime($currhour+1,0,0);

    // Now update the database
    $db->query("INSERT INTO eventproc (nextrun,gameid) VALUES (
                        '$nextrun',
                        '$cgameid')");
  } else {
    // If the script has been run before, get the needed vars
    while ($r_ep = $db->getArray($res_ep)) {
      $nextrun = $r_ep['nextrun'];

      $time_now = time();

      // This is just in case the eventproc had to loose a few minutes
      // The current hour

      $curplace = (3600 / $ticktime);

      $currhour = date("G");
      //$mult = 1;
      if ($curplace > 1) {
        for ($a = 0; $a <= $curplace - 1; $a++) {
          // Debugging
          /*
          die(strval(strtotime("+".($ticktime * ($a+1))." seconds",mktime($currhour,0,0)))."<br />".
              strval(strtotime("+".($ticktime * ($a+2))." seconds",mktime($currhour,0,0)))."<br />".
              strval(time()));*/

          if (time() >  strtotime("+".($ticktime * $a)." seconds",mktime($currhour,0,0)) &&
              time() <= strtotime("+".($ticktime * ($a+1))." seconds",mktime($currhour,0,0))) {

            $mult = $a+1;
          }
        }
      } else {
        $mult = 1;
      }

      // When is the next run
      $chkrun = mktime($currhour,0,0);
      $chkrun = strtotime("+".($ticktime * $mult)." seconds", $chkrun);

      if ($time_now >= $nextrun) {
        // First determine how many times the script needs to be run
        $run_times = floor((($time_now + $ticktime) - $nextrun) / $ticktime);

        // The $run_times variable is used in for loops in the
        // scripts that need to be run, so do not change its name

        // Run the needed scripts

        include("turns.php");
        include("ports_new.php");
        include("alliance_exp.php");
        include("deliveries.php");
        include("constructions.php");
        include("stationshields.php");

        /* Now calculate when the script next needs to be run
         * To do this, you see what the difference is between the
         * current time, and the time that the script was scheduled
         * to be run, then you subtract the difference from the tick
         * time, and add that to the current time to get the next
         * tick time.
         */

        /* First we need to see if we need to manipulate the nextrun
         * variable from the database, we need to do this to ensure
         * that the difference we have is correct. For example, if
         * the script was last run 2 hours ago, with a tick time of
         * 30 mins, that will be 4 ticks. If we just simply calculate
         * the difference and add that to the current time to get the
         * next run time, the next tick will only occur in 2 hours
         * time!
         */

        if ($run_times > 1) {
          /* If we had to run the script more than once, then a tick
           * has been missed. Remember, if for instance the script
           * had to be run 2 times, we only missed 1 tick, the second
           * tick is currently being processed.
           */

          $addition = $ticktime * ($run_times - 1);
        } else {
          /* If we only needed to run the script once, then we have
           * not missed a single tick, therefore nothing will be
           * added to the nextrun db variable
           */

          $addition = 0;
        }

        // Now add the above calculated values to nextrun
        $nextrun += $addition;

        // Now we calculate the difference between the two times
        //$difference = $time_now - $nextrun;

        /* Now we subtract the difference from the time we add to
         * nextrun
         */

        $nextrun = $nextrun + $ticktime;

        if ($chkrun != $nextrun) {
          $db->query("UPDATE eventproc SET nextrun = '$chkrun'
                            WHERE gameid='$cgameid'");
        } else {
          // Now update the database with the new value
          $db->query("UPDATE eventproc SET nextrun = '$nextrun'
                            WHERE gameid='$cgameid'");
        }

      }
    }
  }

  }


?>
