<?php

/**
 * Bank class
 *
 * All bank operations are located here.
 */
class Bank {

  /**
   * Get all the info on a bank account
   *
   * This function will return all the relevant information about a bank account
   *
   * @param integer $playerid
   */
  function bankinfo($playerid,$gameid) {
    $res = dbaccess::query("SELECT * FROM `".$gameid."_bankaccounts` WHERE playerid='$playerid'");
    while ($rac = dbaccess::getarray($res)) {
      $bankinfo['credits'] = $rac['credits'];
      $bankinfo['accid']   = $rac['id'];
    }

    if (empty($bankinfo)) {
      return FALSE;
    } else {
      return $bankinfo;
    }
  }

  /**
   * Increase credits in the bank
   *
   * This function will increase the amount of credits that are currently in the
   * bank account. The alliance variable is there incase the account that the
   * credits are being deposited to is an alliance account. This function will
   * also decrease the amount of credits in the players current credits.
   *
   * @param integer $playerid
   * @param integer $amnt
   * @param integer $alliance
   */
  function upbank($playerid, $amnt, $gameid, $alliance = '0', $anon = '0') {
    if ($anon != 0) {
      $res = dbaccess::query("SELECT * FROM `".$gameid."_bankaccounts` WHERE anonid='$anon'");

      while ($r = dbaccess::getarray($res)) {
        $creds = $r['credits'];
        $accid = $r['id'];
      }

      $creds += $amnt;

      dbaccess::query("UPDATE `".$gameid."_bankaccounts` SET credits='$creds' WHERE id='$accid'");
    }

    if (($alliance == 0) and ($anon == 0)) {
      $res = dbaccess::query("SELECT * FROM `".$gameid."_bankaccounts` WHERE playerid='$playerid'");
      if (dbaccess::numresults($res) == 0) {
        dbaccess::query("INSERT INTO `".$gameid."_bankaccounts` (playerid) VALUES ('$playerid')");
      }

      $bankinfo = currentsector::bankinfo($playerid,$gameid);
      $creds = $bankinfo['credits'];
      $accid = $bankinfo['accid'];

      $creds += $amnt;

      dbaccess::query("UPDATE `".$gameid."_bankaccounts` SET credits='$creds' WHERE id='$accid'");

    } elseif (($alliance != 0) and ($anon == 0)) {
      $res = dbaccess::query("SELECT * FROM `".$gameid."_bankaccounts` WHERE allianceid='$alliance'");
      if (dbaccess::numresults($res) == 0) {
        return FALSE;
      }
    }

  }

  /**
   * Decrease credits in a bank account
   *
   * This function performs the exact opposite of the upbank function.
   *
   * @see upbank()
   * @param integer $playerid
   * @param integer $amnt
   * @param integer $alliance
   */
  function downbank($playerid, $amnt, $gameid, $alliance = '0', $anon = '0') {
    if ($anon != 0) {
      $res = dbaccess::query("SELECT * FROM `".$gameid."_bankaccounts` WHERE anonid='$anon'");

      while ($r = dbaccess::getarray($res)) {
        $creds = $r['credits'];
        $accid = $r['id'];
      }

      $creds -= $amnt;

      dbaccess::query("UPDATE `".$gameid."_bankaccounts` SET credits='$creds' WHERE id='$accid'");
    }

    if (($alliance == 0) and ($anon == 0)) {
      $res = dbaccess::query("SELECT * FROM `".$gameid."_bankaccounts` WHERE playerid='$playerid'");
      if (dbaccess::numresults($res) == 0) {
        dbaccess::query("INSERT INTO `".$gameid."_bankaccounts` (playerid) VALUES ('$playerid')");
      }

      $bankinfo = currentsector::bankinfo($playerid,$gameid);
      $creds = $bankinfo['credits'];
      $accid = $bankinfo['accid'];

      $creds -= $amnt;

      dbaccess::query("UPDATE `".$gameid."_bankaccounts` SET credits='$creds' WHERE id='$accid'");

    } elseif (($alliance != 0) and ($anon == 0)) {
      $res = dbaccess::query("SELECT * FROM `".$gameid."_bankaccounts` WHERE allianceid='$alliance'");
      if (dbaccess::numresults($res) == 0) {
        return FALSE;
      }
    }

  }

}

?>
