<?php

/**
 * Game operations class<br>
 * Better documentation for this class' functions is being worked on.
 *
 * This class handles all the operations needed for the game to run
 * smoothly, it is becoming quite big so I am considering splitting
 * it up into smaller classes with more descriptive names, for instance,
 * use a class called Player for all the functions that handle the player.
 *
 */
class CurrentSector {

  /**
   * Return sector id from record id
   *
   * This function will take the record id (from the database) and retrieve
   * the sector id (the id displayed to the players) to be returned.
   *
   * @param integer $id
   * @return integer The sector id of the given record id
   */
  function secid($id, $gameid, $galid) {
    $resc = dbaccess::query("SELECT * FROM `".$gameid."_sectors` WHERE id='$id' AND galid='$galid'");
    while ($rc = dbaccess::getArray($resc)) {
      $secid = $rc['sector_id'];
    }

    return $secid;
  }

  /**
   * Return id from sector x and y coordinates
   *
   * This function will take the X and Y coordinates of a sector and return the
   * record id (not the one displayed in the game) for further usage.
   *
   * @param integer $x
   * @param integer $y
   * @return integer The record id of a sector
   */
  function getid($x,$y,$gameid,$galid) {
    $resc = dbaccess::query("SELECT * FROM `".$gameid."_sectors` WHERE xcoord = '$x' AND ycoord = '$y' AND galid='$galid'");
    while ($rc = dbaccess::getArray($resc)) {
      $id = $rc['id'];
    }

    return $id;
  }

  /**
   * Return the record id from the sector id
   *
   * This function will accept the sector id of a sector (the id displayed in the game)
   * and return the record id of the sector (the id not shown in the game).
   *
   * @param integer $secid
   * @return integer Record id of sector
   */
  function idfromsecid($secid,$gameid,$galid) {
    $resc = dbaccess::query("SELECT * FROM `".$gameid."_sectors` WHERE sector_id='$secid' AND galid='$galid'");
    while ($rc = dbaccess::getArray($resc)) {
      $id = $rc['id'];
    }

    if (empty($id)) {
      return FALSE;
    } else {
      return $id;
    }
  }

  /**
   * Return port id of a port in the current sector
   *
   * This function will accept the record id of a sector and return the port
   * id of the port located there. If there is no port present this function
   * will return 0 indicating no port.
   *
   * @param integer $id
   * @return integer ID of port
   */
  function hasport($id,$gameid,$galid) {
    $resc = dbaccess::query("SELECT * FROM `".$gameid."_sectors` WHERE id='$id' AND galid='$galid'");
    while ($rc = dbaccess::getArray($resc)) {
      $port_id = $rc['port_id'];
    }

    return $port_id;
  }

  function hasstat($id,$gameid) {
    $resc = dbaccess::query("SELECT * FROM `".$gameid."_stations` WHERE secid='$id'");
    while ($rc = dbaccess::getArray($resc)) {
      $statid = $rc['id'];
    }

    return $statid;
  }

  /**
   * Checks to see if there is a station present
   *
   * This function will return 1 if there is a station present at the
   * current port, or 0 if there is no station.
   *
   * @param integer $id
   * @return integer 1 or 0
   */
  function hasStation($id,$gameid) {
    global $station_e;
    $station_e = 0;
    $resc = dbaccess::query("SELECT * FROM `".$gameid."_ports` WHERE id='$id'");
    while ($rc = dbaccess::getarray($resc)) {
      $station_e = $rc['station'];
    }

    return $station_e;
  }

  /**
   * Check sector exists
   *
   * This function simply checks if the current sector has a top exit.
   * If there is no exit to the top, this function will return 0
   *
   * @param integer $x
   * @param integer $y
   * @param integer $gameid
   * @return integer The id of the sector above current sector
   */
  function hastopexit($x,$y, $gameid, $galid) {
    global $restop, $exists, $id, $rtop;
    $top = $y - 1;
    $restop = dbaccess::query("SELECT * FROM `".$gameid."_sectors` WHERE ycoord = '$top' AND xcoord = '$x' AND galid='$galid'");

    $exists = dbaccess::numResults($restop);
    if ($exists != 0) {
      while ($rtop = dbaccess::getArray($restop)) {
        $id = $rtop['id'];
      }
    } else {
      $id = 0;
    }

    return $id;
  }

  /**
   * Check sector exists
   *
   * This function simply checks if the current sector has a bottom exit.
   * If there is no exit to the bottom, this function will return 0
   *
   * @param integer $x
   * @param integer $y
   * @param integer $gameid
   * @return integer The id of the sector below current sector
   */
  function hasbottomexit($x,$y,$gameid, $galid) {
    global $restop, $exists, $id, $rtop;
    $bottom = $y + 1;
    $restop = dbaccess::query("SELECT * FROM `".$gameid."_sectors` WHERE ycoord = '$bottom' AND xcoord = '$x' AND galid='$galid'");

    $exists = dbaccess::numResults($restop);
    if ($exists != 0) {
      while ($rtop = dbaccess::getArray($restop)) {
        $id = $rtop['id'];
      }
    } else {
      $id = 0;
    }

    return $id;
  }

  /**
   * Check sector exists
   *
   * This function simply checks if the current sector has a left exit.
   * If there is no exit to the left, this function will return 0
   *
   * @param integer $x
   * @param integer $y
   * @param integer $gameid
   * @return integer The id of the sector to the left of the current sector
   */
  function hasleftexit($x,$y,$gameid,$galid) {
    global $restop, $exists, $id, $rtop;
    $left = $x - 1;
    $restop = dbaccess::query("SELECT * FROM `".$gameid."_sectors` WHERE ycoord = '$y' AND xcoord = '$left' AND galid='$galid'");

    $exists = dbaccess::numResults($restop);
    //die($exists);
    if ($exists > 0) {
      while ($rtop = dbaccess::getArray($restop)) {
        $id = $rtop['id'];
      }
    } else {
      $id = 0;
    }

    return $id;
  }

  /**
   * Check sector exists
   *
   * This function simply checks if the current sector has a right exit.
   * If there is no exit to the right this function will return 0
   *
   * @param integer $x
   * @param integer $y
   * @param integer $gameid
   * @return integer The id of the sector to the right of the current sector
   */
  function hasrightexit($x,$y,$gameid,$galid) {
    global $restop, $exists, $id, $rtop;
    $right = $x + 1;
    $restop = dbaccess::query("SELECT * FROM `".$gameid."_sectors` WHERE ycoord = '$y' AND xcoord = '$right' AND galid='$galid'");

    $exists = dbaccess::numResults($restop);
    if ($exists != 0) {
      while ($rtop = dbaccess::getArray($restop)) {
        $id = $rtop['id'];
      }
    } else {
      $id = 0;
    }

    return $id;
  }

  /**
   * Has the current sector got drones
   *
   * This function will check the sector specified through $sec (note this is
   * the database record id, not the publically viewable sector_id) for the
   * presance of drones.
   *
   * @param integer $sec
   * @param integer $gameid
   * @return boolean TRUE or FALSE
   */
  function hasdrones($sec,$gameid) {
    $res = dbaccess::query("SELECT * FROM `".$gameid."_drones` WHERE secid='$sec'");
    $hasds = dbaccess::numresults($res);

    if ($hasds > 0) {
      return TRUE;
    } else {
      return FALSE;
    }
  }

  /**
   * Locate the nearest station
   *
   * This function will locate the nearest station to the current sector, note
   * that it doesn't locate the nearest planet, the planet has to be a station.
   * The current sector is specified through $sec, this is the database record
   * id, not the publically viewable sector_id.
   *
   * @param integer $sec
   * @param integer $gameid
   * @return array Distance and Sector ID of nearest station.
   */
  function neareststation($sec,$gameid, $galid) {

    $res = dbaccess::query("SELECT * FROM `".$gameid."_sectors` WHERE id='$sec' AND galid='$galid'");
    while ($r = dbaccess::getArray($res)) {
      $cx = $r['xcoord'];
      $cy = $r['ycoord'];
      $sector_id = $r['sector_id'];
    }

    $res = dbaccess::query("SELECT * FROM `".$gameid."_ports`,`".$gameid."_sectors` WHERE ".$gameid."_ports.station = '1' AND ".$gameid."_sectors.port_id = ".$gameid."_ports.id AND ".$gameid."_sectors.galid='$galid'");
    $nx = $cx;
    $ny = $cy;
    $cdist = 0;
    $init = 0;
    while ($rac = dbaccess::getarray($res)) {
      $secid = $rac['sector_id'];
      //$res2 = dbaccess::query("SELECT * FROM `".$gameid."_sectors` WHERE sector_id = '$secid' AND galid='$galid'");
      //while ($rec = dbaccess::getarray($res2)) {
      //  $tx = $rec['xcoord'];
      //  $ty = $rec['ycoord'];
      //}
      $tx = $rac['xcoord'];
      $ty = $rac['ycoord'];

      $dist = abs($nx - $tx) + abs($ny - $ty);
      if ($dist == 0) {
        $cdist = 0;
        $dsecid = $secid;
      } elseif (($cdist == 0) and ($init == 0)) {
        $cdist = $dist;
        $dsecid = $secid;
        $init = 1;
      } elseif (($dist > 0) and ($dist < $cdist)) {
        $cdist = $dist;
        $dsecid = $secid;
      }
    }

    $returnvals['cdist']  = $cdist;
    $returnvals['dsecid'] = $dsecid;

    return $returnvals;

  }

  /**
   * Distance between two sectors
   *
   * This function calculates the distance between two sectors specified through
   * $sec and $sec2, these id's are record id's and not publically viewable
   * sector_id's
   *
   * @param integer $sec
   * @param integer $sec2
   * @param integer $gameid
   * @return integer Distance between $sec and $sec2
   */
  function getdist($sec,$sec2,$gameid, $galid) {

    $res = dbaccess::query("SELECT * FROM `".$gameid."_sectors` WHERE id='$sec' AND galid='$galid'");
    while ($r = dbaccess::getArray($res)) {
      $cx = $r['xcoord'];
      $cy = $r['ycoord'];
      $sector_id = $r['sector_id'];
    }

    $nx = $cx;
    $ny = $cy;
    $cdist = 0;
    $init = 0;

    $res2 = dbaccess::query("SELECT * FROM `".$gameid."_sectors` WHERE id = '$sec2' AND galid='$galid'");
    while ($rec = dbaccess::getarray($res2)) {
      $tx = $rec['xcoord'];
      $ty = $rec['ycoord'];
    }
    $dist = abs($nx - $tx) + abs($ny - $ty);
    if ($dist == 0) {
      $cdist = 0;
    } elseif (($cdist == 0) and ($init == 0)) {
      $cdist = $dist;
      $init = 1;
    } elseif (($dist > 0) and ($dist < $cdist)) {
      $cdist = $dist;
    }

    return $cdist;

  }

  /**
   * Check sector for wormhole
   *
   * Check whether the sector specified through $sec has a wormhole, note that
   * $sec is the database record id.
   * This function will return information about the wormhole if there is a
   * wormhole present, or 0 if there is none.
   *
   * @param integer $sec
   * @param integer $gameid
   * @return mixed Array or 0.
   */
  function haswormhole($sec,$gameid,$galid) {
    $res = dbaccess::query("SELECT * FROM `".$gameid."_wormholes` WHERE secid=".$sec." AND galid='$galid';");
    if (dbaccess::numresults($res) > 0) {
      while ($r = dbaccess::getarray($res)) {
        $return['secid']     = $r['secid'];
        $return['goto']      = $r['goto'];
        $return['stability'] = $r['stability'];
	    $return['galid']     = $r['galid'];
        $return['linkto']    = $r['linkto'];
	  }
	} else {
	  $return = 0;
	}

	return $return;
  }

  /**
   * The name of the galaxy
   *
   * Get the name of the galaxy the current sector, specified through $sec, is
   * located in.
   *
   * @param integer $sec
   * @param integer $gameid
   * @return string Galaxy name
   */
  function getgalname($sec,$gameid) {

    $res = dbaccess::query("SELECT `galid` FROM `".$gameid."_sectors` WHERE `id`='$sec' LIMIT 1");
    $res = dbaccess::getrow($res);
    $galid = $res[0];

    $res = dbaccess::query("SELECT `name` FROM `".$gameid."_galaxies` WHERE `id`='$galid' LIMIT 1");
    $res = dbaccess::getrow($res);
    return $res[0];

  }

}

?>
