<?php

/**
 * Tech class
 *
 * All information and functions regarding weapons and equipment, collectivly
 * technology, will go through this class.
 */
class Tech {

  /**
   * Return info on a weapon
   *
   * This function will accept the weapon id of a weapon, and then return
   * everything about that weapon in an array
   *
   * @param integer $weaponid
   * @return array Info on a weapon
   */
  function getweaponinfo($weaponid) {
    $resc = dbaccess::query("SELECT * FROM weapons WHERE id='$weaponid'");
    while ($ra = dbaccess::getarray($resc)) {
      $weaponinfo['name']       = $ra['name'];
      $weaponinfo['hulls']      = $ra['hulls'];
      $weaponinfo['damage']     = $ra['damage'];
      $weaponinfo['baseprice']  = $ra['baseprice'];
      $weaponinfo['multiplier'] = $ra['multiplier'];
    }

    return $weaponinfo;
  }

  /**
   * Return info on all technology
   *
   * This function accepts no parameters, it returns all the information on
   * all technology in the database.
   *
   * @return array Technology info on all technology.
   */
  function gettechinfo() {
    $resc = dbaccess::query("SELECT * FROM technology");
    while ($ra = dbaccess::getarray($resc)) {
      $tech[$ra['id']]['name'] = $ra['name'];
      $tech[$ra['id']]['prop'] = $ra['properties'];
      $tech[$ra['id']]['bp']   = $ra['baseprice'];
      $tech[$ra['id']]['mult'] = $ra['multiplier'];
    }
    return $tech;
  }

  function pickupdrone($sector,$type,$amnt,$owner,$gameid) {
    if ($type == 'sd') {
      $res = dbaccess::query("SELECT * FROM `".$gameid."_drones` WHERE secid='$sector' AND owner='$owner' AND type='sd'");
      $dexists = dbaccess::numresults($res);

      if ($dexists > 0) {
        $contains = dbaccess::getrow(dbaccess::query("SELECT id,amnt FROM `".$gameid."_drones` WHERE secid='$sector' AND owner='$owner' AND type='sd'"));
        $rowid = $contains[0];
        $contains = $contains[1];

        $newsd = $contains - $amnt;

        if ($newsd != 0) {
          dbaccess::query("UPDATE `".$gameid."_drones` SET amnt='$newsd' WHERE id='$rowid' LIMIT 1");
        } else {
          dbaccess::query("DELETE FROM `".$gameid."_drones` WHERE id='$rowid'");
        }
      }

      $shipinfo = ship::getshipinfo($owner,$gameid);
      $current_sd = $shipinfo['currentsd'];
      $current_sd += $amnt;

      ship::changeequip('sd', $amnt, $owner, $gameid);
    }

    if ($type == 'cd') {
      $res = dbaccess::query("SELECT * FROM `".$gameid."_drones` WHERE secid='$sector' AND owner='$owner' AND type='cd'");
      $dexists = dbaccess::numresults($res);

      if ($dexists > 0) {
        $contains = dbaccess::getrow(dbaccess::query("SELECT id,amnt FROM `".$gameid."_drones` WHERE secid='$sector' AND owner='$owner' AND type='cd'"));
        $rowid = $contains[0];
        $contains = $contains[1];

        $newsd = $contains - $amnt;

        if ($newsd != 0) {
          dbaccess::query("UPDATE `".$gameid."_drones` SET amnt='$newsd' WHERE id='$rowid' LIMIT 1");
        } else {
          dbaccess::query("DELETE FROM `".$gameid."_drones` WHERE id='$rowid'");
        }
      }

      $shipinfo = ship::getshipinfo($owner,$gameid);
      $current_sd = $shipinfo['currentcd'];
      $current_sd += $amnt;

      ship::changeequip('cd', $amnt, $owner, $gameid);
    }
  }

  function dropdrone($sector,$type,$amnt,$owner,$gameid) {
    if ($type == 'sd') {
      $res = dbaccess::query("SELECT * FROM `".$gameid."_drones` WHERE secid='$sector' AND owner='$owner' AND type='sd'");
      $dexists = dbaccess::numresults($res);

      if ($dexists > 0) {
        $contains = dbaccess::getrow(dbaccess::query("SELECT id,amnt FROM `".$gameid."_drones` WHERE secid='$sector' AND owner='$owner' AND type='sd'"));
        $rowid = $contains[0];
        $contains = $contains[1];

        $newsd = $contains + $amnt;

        dbaccess::query("UPDATE `".$gameid."_drones` SET amnt='$newsd' WHERE id='$rowid' LIMIT 1");
      } else {
        dbaccess::query("INSERT INTO `".$gameid."_drones` (secid,owner,type,stance,amnt,claim) VALUES (
                            '$sector',
                            '$owner',
                            '$type',
                            'Guard Sector',
                            '$amnt',
                            '0')");
      }

      $shipinfo = ship::getshipinfo($owner,$gameid);
      $current_sd = $shipinfo['currentsd'];
      $current_sd -= $amnt;

      // While this functions name refers to being attacked, it only removes some equipment
      // from a players ship.
      ship::changeequipattack('sd', $amnt, $owner, $gameid);
    }

    if ($type == 'cd') {
      $res = dbaccess::query("SELECT * FROM `".$gameid."_drones` WHERE secid='$sector' AND owner='$owner' AND type='cd'");
      $dexists = dbaccess::numresults($res);

      if ($dexists > 0) {
        $contains = dbaccess::getrow(dbaccess::query("SELECT id,amnt FROM `".$gameid."_drones` WHERE secid='$sector' AND owner='$owner' AND type='cd'"));
        $rowid = $contains[0];
        $contains = $contains[1];

        $newsd = $contains + $amnt;

        dbaccess::query("UPDATE `".$gameid."_drones` SET amnt='$newsd' WHERE id='$rowid' LIMIT 1");
      } else {
        dbaccess::query("INSERT INTO `".$gameid."_drones` (secid,owner,type,stance,amnt,claim) VALUES (
                            '$sector',
                            '$owner',
                            '$type',
                            'Guard Sector',
                            '$amnt',
                            '0')");
      }

      $shipinfo = ship::getshipinfo($owner,$gameid);
      $current_sd = $shipinfo['currentcd'];
      $current_sd -= $amnt;

      // While this functions name refers to being attacked, it only removes some equipment
      // from a players ship.
      ship::changeequipattack('cd', $amnt, $owner, $gameid);
    }
  }


}

?>
