<?php

  class template {

    var $page;
    var $box;
    var $box_right;
    var $box_title;
    var $box_content_head;
    var $box_content_foot;
    var $stpl;
    var $compfiles = array();
    var $tpl_data = array();
    var $tpl_logic = array();

    function template($tpl = 'templates/tmFX/') {

      if ((file_exists($tpl.'tpl.php'))) {
        $this->page = join('', file($tpl.'tpl.php'));
        if (file_exists($tpl.'box.php')) {
          $this->box  = join('', file($tpl.'box.php'));
        } else {
          $this->box_right = join('', file($tpl.'side_box.php'));
          $this->box = join('', file($tpl.'main_box.php'));
        }

        $this->stpl = $tpl;

        $boxes = $this->box;
        $boxes = preg_replace("/[\r\n]+[\s\t]*[\r\n]+/","",$boxes);
        $boxes = preg_replace("/[\n]+/","",$boxes);

        if (preg_match('/\[tplhead\](.*?)\[\/tplhead\]/', $boxes, $matches)) {
          $this->box_title = $matches[1];
          $this->box = preg_replace('/\[tplhead\]/', "", $this->box);
          $this->box = preg_replace('/\[\/tplhead\]/', "", $this->box);
        }
        if (preg_match("/\[tplcontent\](.*?)\[\/tplcontent\]/", $boxes, $matches)) {
          preg_match("/\[tplcontent\](.*)\{content\}/", $boxes, $boxhead);
          $this->box_content_head = $boxhead[1];
          preg_match("/\{content\}(.*)\[\/tplcontent\]/", $boxes, $boxfoot);
          $this->box_content_foot = $boxfoot[1];

          $this->box = preg_replace("/\[tplcontent\]/", "", $this->box);
          $this->box = preg_replace("/\[\/tplcontent\]/", "", $this->box);
        }

        $spage = $this->page;
        $spage = preg_replace("/[\r\n]+[\s\t]*[\r\n]+/","",$spage);
        $spage = preg_replace("/[\n]+/","",$spage);
        if (preg_match("/<!-- IF (.*?) -->/", $spage, $matches)) {
          //die($matches[1]);
          if (preg_match("/<!-- IF ".$matches[1]." -->(.*?)<!-- ELSE -->(.*?)<!-- END IF -->/", $spage, $matches2)) {
            $this->tpl_logic[$matches[1]]['if'] = $matches2[1];
            $this->tpl_logic[$matches[1]]['else'] = $matches2[2];
            //die($matches2[2]);
            $spage = preg_replace("/<!-- IF ".$matches[1]." -->(.*?)<!-- ELSE -->/", "{".$matches[1]." if} <!-- ELSE ".$matches[1]." -->", $spage);
            $spage = preg_replace("/<!-- ELSE ".$matches[1]." -->(.*?)<!-- END IF -->/", "{".$matches[1]." else}", $spage);
            //die($spage);
          }
        }

        $this->page = $spage;

        //$this->page = $spage;
      } else {
        return FALSE;
      }

    } /* End Function template */

    function insert_box_title($title,$width='95%') {

      $tmphead = $this->box_title;
      $tmphead = eregi_replace("{title}", $title, $tmphead);
      $tmphead = eregi_replace("{width}", $width, $tmphead);
      return $tmphead;

    } /* End function insert_box_title */

    function insert_box_chead() {

      return $this->box_content_head;

    }

    function insert_box_cfoot() {

      return $this->box_content_foot;

    }

    function parse($file) {

      global $db, $tm_bank, $tm_current_sector, $tm_player, $tm_port, $tm_ship,
             $tm_sstation, $tm_tech;

      ob_start();
        include($file);
        $buffer = ob_get_contents();
      ob_end_clean();
      return $buffer;

    } /* End Function parse */

    function make_box($tags = array(),$compiled) {

      $tmpbox = $this->box;
      if (sizeof($tags) > 0) {
        foreach ($tags as $tag => $data) {
          $data = ($this->checkDir($data)) ? $this->parse($data) : $data;
          $tmpbox = eregi_replace("{" . $tag . "}", $data, $tmpbox);
          $tmpbox = eregi_replace("{dir}", $this->stpl, $tmpbox);
        }
        //$handle = fopen("compiled/" . $compiled, "a");
        if (array_search($compiled, $this->compfiles) === FALSE) {
          $this->compfiles[] = $compiled;
          $this->tpl_data[$compiled] = $tmpbox;
          //fwrite($handle, $tmpbox);
        } else {
          $this->tpl_data[$compimed] .= '<br />' . $tmpbox;
          //fwrite($handle, "<br />" . $tmpbox);
        }
        //fclose($handle);

      } else {
        return FALSE;
      }

    } /* End function make_box */

    function insert_box($tags = array()) {

      $tmpbox = $this->box;
      if (sizeof($tags) > 0) {
        foreach ($tags as $tag => $data) {
          $data = ($this->checkDir($data)) ? $this->parse($data) : $data;
          $tmpbox = eregi_replace("{" . $tag . "}", $data, $tmpbox);
          $tmpbox = eregi_replace("{dir}", $this->stpl, $tmpbox);
        }
        return $tmpbox;
      } else {
        return FALSE;
      }

    } /* End function insert_box */

    function insert_page($page,$compiled) {

      $data = $page;
      $data = ($this->checkDir($data)) ? $this->parse($data) : $data;
      //$handle = fopen("compiled/" . $compiled, "a");
      if (array_search($compiled, $this->compfiles) === FALSE) {
        $this->compfiles[] = $compiled;
        $this->tpl_data[$compiled] = $data;
        //fwrite($handle, $data);
      } else {
        $this->tpl_data[$compiled] .= '<br />' . $data;
        //fwrite($handle, "<br />" . $data);
      }
      //fclose($handle);

    } /* End function insert_page */

    function make_mult_box($boxes = array()) {

      $tmpbox = $this->box;
      if (sizeof($boxes) > 0) {
        foreach ($boxes as $box) {
          foreach ($box as $tag => $data) {
            if ($tag == 'file') {
              $forfile = $data;
            } else {
              if ((preg_match("/(.*?)\.php/", $data)) and (file_exists($data))) {
                $data = $this->parse($data);
              } else {
                $data = $data;
              }
              $tmpbox = eregi_replace("{" . $tag . "}", $data, $tmpbox);
              $tmpbox = eregi_replace("{dir}", $this->stpl, $tmpbox);
            }
          }
          //$handle = fopen("compiled/" . $forfile, "a");
          if (array_search($forfile, $this->compfiles) === FALSE) {
            $this->compfiles[] = $forfile;
            $this->tpl_data[$forfile] = $tmpbox;
            //fwrite($handle, $tmpbox);
          } else {
            $this->tpl_data[$forfile] .= '<br />' . $tmpbox;
            //fwrite($handle, "<br />" . $tmpbox);
          }
          //fclose($handle);
          $tmpbox = $this->box;
        }

      } else {
        return FALSE;
      }

    } /* End function make_mult_box */

    function make_mult_box_right($boxes = array()) {

      $tmpbox = $this->box_right;
      if (sizeof($boxes) > 0) {
        foreach ($boxes as $box) {
          foreach ($box as $tag => $data) {
            if ($tag == 'file') {
              $forfile = $data;
            } else {
              if ((preg_match("/(.*?)\.php/", $data)) and (file_exists($data))) {
                $data = $this->parse($data);
              } else {
                $data = $data;
              }
              $tmpbox = eregi_replace("{" . $tag . "}", $data, $tmpbox);
              $tmpbox = eregi_replace("{dir}", $this->stpl, $tmpbox);
            }
          }
          //$handle = fopen("compiled/" . $forfile, "a");
          if (array_search($forfile, $this->compfiles) === FALSE) {
            $this->compfiles[] = $forfile;
            $this->tpl_data[$forfile] = $tmpbox;
            //fwrite($handle, $tmpbox);
          } else {
            $this->tpl_data[$forfile] .= '<br />' . $tmpbox;
            //fwrite($handle, "<br />" . $tmpbox);
          }
          //fclose($handle);
          $tmpbox = $this->box_right;
        }

      } else {
        return FALSE;
      }

    } /* End function make_mult_box_right */

    function checkDir($dir) {

      if (preg_match('/^(.*?)\/(.*?)\.(.*?)$/', $dir)) {
        // It could be a file
        if (is_file($dir)) {
          return TRUE;
        } else {
          return FALSE;
        }
      }
      if (preg_match('/^[0-9a-zA-Z\-\_]{0,}\/?$/', $dir)) {
        // It could be a dir
        if (is_dir($dir)) {
          return TRUE;
        } else {
          return FALSE;
        }
      }

    }

    function replace_tags($tags = array()) {

      if (sizeof($tags) > 0) {
        foreach ($tags as $tag => $data) {
          if (preg_match("/\{\=(.*)\}/", $data, $matches)) {
            if ($this->checkDir("compiled/".$matches[1])) {
              $data = $this->parse("compiled/" . $matches[1]);
            } else {
              $data = $this->tpl_data[$matches[1]];
            }
          }
          $data = ($this->checkDir($data)) ? $this->parse($data) : $data;
          $this->page = eregi_replace("{" . $tag . "}", $data, $this->page);
          $this->page = eregi_replace("{dir}", $this->stpl, $this->page);
          //die($this->tpl_data);
        }
      } else {
        return FALSE;
      }

    } /* End function replace_tags */

    function replace_logic_tag($logic,$ifelse) {


          $data = $this->tpl_logic[$logic][$ifelse];

          $data = ($this->checkDir($data)) ? $this->parse($data) : $data;
          $this->page = eregi_replace("{" . $logic . " " . $ifelse . "}", $data, $this->page);
          $this->page = eregi_replace("{dir}", $this->stpl, $this->page);

          switch($ifelse) {
            case 'if'   : $other = 'else';
                          break;
            case 'else' : $other = 'if';
                          break;
          }

          if (!empty($this->tpl_logic[$logic][$other])) {
            $this->page = eregi_replace("{" . $logic . " " . $other . "}", "", $this->page);
          }
          //die($this->tpl_data);

    } /* End function replace_tags */

    function output() {

    /*
      if(sizeof($this->compfiles) > 0) {
        foreach ($this->compfiles as $key => $file) {
          unlink("compiled/" . $file);
        }
      } */

      //die(print_r($this->tpl_data));

      print($this->page);

      unset($this->page);
      $this->tpl_data = array();
      $this->compfiles = array();


    } /* End function output */
  }
?>
