<?php

    /* This is the prepend script, it contains the includes needed for the game
       game to work. It also contains the variable references to the classes */

    // Where are we?
    //$folder = strpos($_SERVER['PHP_SELF'],"index.php");
    $folder = preg_match('/^([a-zA-Z0-9_\-\/]{0,})\/((.*?)\.php)$/si', $_SERVER['PHP_SELF'], $matches);
    define("MY_PATH",   $_SERVER['DOCUMENT_ROOT'].$matches[1].'/');
    define("MY_URI" ,   $matches[1].'/');

    if (preg_match('/^(.*?)\/index\.php$/', $_SERVER['PHP_SELF'], $matches) or
        preg_match('/^(.*?)\/help\.php$/', $_SERVER['PHP_SELF'], $matches)) {
        define("ROOT_PATH", $_SERVER['DOCUMENT_ROOT'].$matches[1].'/');
    } else {
        $myself = explode('/', $_SERVER['PHP_SELF']);

        // Loose the filename
        unset($myself[count($myself) - 1]);
        // Loose the sub directory, eg /scripts/
        unset($myself[count($myself) - 1]);

        $myself = implode('/', $myself);

        define("ROOT_PATH", $_SERVER['DOCUMENT_ROOT'].$myself.'/');
    }


    // Include global configuration
    include(ROOT_PATH . 'config.inc.php');

    // Include class libs
    include(ROOT_PATH . 'includes/class_bank.php');
    include(ROOT_PATH . 'includes/class_currentsector.php');
    include(ROOT_PATH . 'includes/class_dbaccess.php');
    include(ROOT_PATH . 'includes/class_player.php');
    include(ROOT_PATH . 'includes/class_port.php');
    include(ROOT_PATH . 'includes/class_ship.php');
    include(ROOT_PATH . 'includes/class_sstation.php');
    include(ROOT_PATH . 'includes/class_tech.php');
    include(ROOT_PATH . 'includes/class_tpl.php');

    // Define the global class refs
    $tm_bank                = new bank;
    $tm_current_sector      = new currentsector;
    $db                     = new dbaccess;
    $tm_player              = new player;
    $tm_port                = new port;
    $tm_ship                = new ship;
    $tm_sstation            = new sstation;
    $tm_tech                = new tech;

    // The tpl class is created when needed in the game, this is due to
    // different templates for different parts of the game.

    // Now include some more libraries that work with maintanance.

    include(ROOT_PATH . 'includes/inactive_logout.php');
    include(ROOT_PATH . 'includes/remnoact.php');

    $res = $db->query("SELECT value FROM server_setup WHERE name = 'version' LIMIT 1");
    $res = $db->getrow($res);
    $version = $res[0];

    // Now define some global constants
    define('TM_VERSION', $version);

    // Is the merchant installed?
    if (!defined('TM_INSTALLED')) {
        header('Location: '. MY_URI .'install/install.php');
        die();
    }

?>
