<?php

  /**
   * Alliance formation page
   *
   * Here a player will be able to form an alliance.
   *
   * <code>
   * if (!empty($_POST['create'])) {
   * </code>
   *
   * Here we check to see if the user has not posted the form already and if
   * we need to create an alliance.
   *
   * <code>
   *   $res = $db->query("SELECT * FROM alliances WHERE name='$aname'");
   *   $exists = $db->numresults($res);
   *
   *   if ($exists > 0) {
   * </code>
   *
   * Here we check to see if the alliance name chosen doesn't already exist.
   *
   * <code>
   *   if ($playerinfo['exp'] < 5000000) {
   *     echo "You do not have enough experience to form an alliance!<br />
   *           You will need at least <b>5,000,000</b> experience to form one.";
   *   } else {
   * </code>
   *
   * If the players experience is less than 5 million, he or she will not be able
   * to create an alliance, and thus an error gets displayed.
   *
   * <code>
   *   if (empty($_POST['create'])) {
   * </code>
   *
   * If the form has not yet been posted, then we must display the form so that
   * the player will be able to put in the request to form an alliance.
   *
   * <code>
   *   } else {
   *     if (empty($error)) {
   *       ?>
   *       Your alliance (<b><?php echo $aname; ?>)</b>) has been formed.<br />
   *       Your password is <b><?php echo $apass; ?></b>
   *       <?php
   *     } else {
   *       echo $error;
   *     }
   *   }
   * </code>
   *
   * Here we check to see if an error has occured, if one has it would have been
   * placed in the $error variable, if it is empty (line 2) then the alliance
   * was created successfully, otherwise the error will be displayed.
   *
   * @package TheMerchant
   * @author Shaun Steenkamp
   * @filesource
   */

  //$db = new dbaccess;
  //$csector = new currentsector;

  $username = $_SESSION['username'];
  $gameid   = $_SESSION['gameid'];
  $playerid = $tm_player->getplayerid($username,$gameid);
  $playerinfo = $tm_player->getplayerinfo($playerid,$gameid);

  if (!empty($_POST['create'])) {
    $aname = $_POST['name'];
    $apass = $_POST['pass'];

    $res = $db->query("SELECT * FROM `".$gameid."_alliances` WHERE name='$aname'");
    $exists = $db->numresults($res);

    $allexp = $playerinfo['exp'];

    if ($exists > 0) {
      $error = '<span style="color: red; font-weight: bold">That alliance name already exists!</span>';
    } elseif (empty($aname)) {
      $error = '<span style="color: red; font-weight: bold">You must enter an alliance name.</span>';
    } elseif (empty($apass)) {
      $error = '<span style="color: red; font-weight: bold">You must enter an alliance password.</span>';
    } else {

      $db->query("INSERT INTO `".$gameid."_alliances` (name,founder,password,exp) VALUES (
                      '$aname',
                      '$playerid',
                      '$apass',
                      '$allexp')");

      $aid = $db->insertid();

      $db->query("UPDATE `".$gameid."_players` SET allianceid = '$aid' WHERE id='$playerid'");
    }
  }

  if ($playerinfo['exp'] < 100000) {
    echo "<div style='text-align: center'>
          You do not have enough experience to form an alliance!<br />
          You will need at least <b>100,000</b> experience to form one.
          </div>";
  } else {
    if (empty($_POST['create'])) {

      $qrystr = $_SERVER['QUERY_STRING'];
      parse_str($qrystr, $gets);
      if (!empty($gets['show'])) {
        unset($gets['show']);
      } if (!empty($gets['all'])) {
        unset($gets['all']);
      }
      $qrystr = '';
      if (sizeof($gets) > 0) {
        foreach ($gets as $opt => $value) {
          $qrystr = $qrystr . $opt . '=' . $value . '&';
        }
      }

      $isfounder = 0;
      $isfounder = $db->numresults($db->query("SELECT * FROM `".$gameid."_alliances` WHERE
                                                founder = ".$playerid));

      if (($playerinfo['alliance'] != 0) and ($isfounder == 0)) {
      ?>
        When you form an alliance you will leave the one you are currently a
        member of!
      <?php
      }
      if ($isfounder != 0) {
      ?>
        You are currently the founder of an alliance, you will have to disband
        that alliance before you can form a new one!
      <?php
      } else {
?>
  <table align='center' width="100%" border=0 cellspacing=3 cellpadding=0>
    <form method="post" action="?<?php echo $qrystr; ?>&show=form">
      <tr>
        <td width="50%" align='right'>
          <b>Alliance Name:</b>
        </td>
        <td align='left'>
          <input name='name' type='text' size='12' />
        </td>
      </tr>
      <tr>
        <td align='right'>
          <b>Alliance Password:</b>
        </td>
        <td align='left'>
          <input name='pass' type='text' size='12' />
        </td>
      </tr>
      <tr>
        <Td colspan='2' align='center'>
          <input name='create' type='submit' value='Create Alliance' />
        </Td>
      </tr>
    </form>
  </table>
<?php
      }
    } else {
      if (empty($error)) {
      ?>
      <div style="text-align: center">
      Your alliance (<b><?php echo $aname; ?></b>) has been formed.<br />
      Your password is <b><?php echo $apass; ?></b>
      </div>
      <?php
      } else {
        echo $error;
      }
    }
  }
?>
